//-----------------------------------------------------------------------------
// Weapon_SFRevolver
// SolarFlare
//-----------------------------------------------------------------------------

datablock DecalData(RevolverIcon)
{
   textureName = "./Icon_sfRevolver_3";
};   

datablock DecalData(RevolverCI)
{
   textureName = "./CI_sfRevolver_3";
};   

//-----------------------------------------------------------------------------
// Sound

datablock AudioProfile(sfRevolverShotSound)
{
   filename    = "./revolverFire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(sfRevolverDrawSound)
{
   filename    = "./revolverDraw.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(sfRevolverReloadSound)
{
   filename    = "./revolverReload.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(sfRevolverSpinSound)
{
   filename    = "./revolverSpin.wav";
   description = AudioClose3d;
   preload = true;
};

//-----------------------------------------------------------------------------
// Muzzle Flash

datablock ParticleData(sfRevolverFlashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.9 0.9 0.0 0.9";
	colors[1]     = "0.9 0.5 0.0 0.0";
	sizes[0]      = 0.5;
	sizes[1]      = 1.0;

	useInvAlpha = false;
};

datablock ParticleEmitterData(sfRevolverFlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "sfRevolverFlashParticle";
};

datablock ParticleData(sfRevolverSmokeParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 525;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 0.5 0.5 0.9";
	colors[1]     = "0.5 0.5 0.5 0.0";
	sizes[0]      = 0.15;
	sizes[1]      = 0.15;

	useInvAlpha = false;
};

datablock ParticleEmitterData(sfRevolverSmokeEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "sfRevolverSmokeParticle";
};

//-----------------------------------------------------------------------------
// Explosion  Particles

datablock ParticleData(sfRevolverExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 700;
	lifetimeVarianceMS   = 400;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.9 0.9 0.9 0.3";
	colors[1]     = "0.9 0.5 0.6 0.0";
	sizes[0]      = 0.25;
	sizes[1]      = 0.75;

	useInvAlpha = true;
};

datablock ParticleEmitterData(sfRevolverExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "sfRevolverExplosionParticle";
};

datablock ParticleData(sfRevolverExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 50;
	lifetimeVarianceMS   = 35;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 500.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 1 0.0 0.9";
	colors[1]     = "0.9 0.0 0.0 0.0";
	sizes[0]      = 1;
	sizes[1]      = 0;

	useInvAlpha = false;
};

datablock ParticleEmitterData(sfRevolverExplosionRingEmitter)
{
	lifeTimeMS = 50;

   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "sfRevolverExplosionRingParticle";
};

//-----------------------------------------------------------------------------
// Explosion

datablock ExplosionData(sfRevolverExplosion)
{
	soundProfile = bulletHitSound;

   lifeTimeMS = 150;

   particleEmitter = sfRevolverExplosionEmitter;
   particleDensity = 5;
   particleRadius = 0.2;

   emitter[0] = sfRevolverExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   lightStartRadius = 0;
   lightEndRadius = 2;
   lightStartColor = "0.3 0.6 0.7";
   lightEndColor = "0 0 0";
};

//-----------------------------------------------------------------------------
// Projectile

AddDamageType("SFRevolver", '<bitmap:add-ons/Weapon_SFRevolver/CI_sfRevolver_3> %1', '%2 <bitmap:add-ons/Weapon_SFRevolver/CI_sfRevolver_3> %1', 0.2, 1);

datablock ProjectileData(sfRevolverWeakProjectile)
{
   projectileShapeName = "Add-Ons/Weapon_Gun/bullet.dts";
   directDamage        = 40;
   directDamageType    = $DamageType::SFRevolver;
   radiusDamageType    = $DamageType::SFRevolver;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;
   brickExplosionMaxVolumeFloating = 2; 

   impactImpulse	     = 400;
   verticalImpulse	  = 400;
   explosion           = sfRevolverExplosion;
   particleEmitter     = "";

   muzzleVelocity      = 140;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0.5 0 0";

   uiName = "";
};

datablock ProjectileData(sfRevolverProjectile)
{
   projectileShapeName = "Add-Ons/Weapon_Gun/bullet.dts";
   directDamage        = 60;
   directDamageType    = $DamageType::SFRevolver;
   radiusDamageType    = $DamageType::SFRevolver;

   brickExplosionRadius = 0;
   brickExplosionImpact = true; 
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;  
   brickExplosionMaxVolumeFloating = 2;

   impactImpulse	     = 400;
   verticalImpulse	  = 400;
   explosion           = sfRevolverExplosion;
   particleEmitter     = "";

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0.5 0 0";

   uiName = "Revolver Bullet";
};

//-----------------------------------------------------------------------------
// Item

datablock ItemData(sfRevolverItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./sfRevolver_3.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Revolver";
	iconName = "./icon_sfRevolver_3";
	doColorShift = false;

	 // Dynamic properties defined by the scripts
	image = sfRevolverImage;
	canDrop = true;
};

//-----------------------------------------------------------------------------
// Weapon Image

datablock ShapeBaseImageData(sfRevolverImage)
{
   // Basic Item properties
   shapeFile = "./sfRevolver_3.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = sfRevolverItem;
   ammo = "";
   projectile = sfRevolverProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = false;
   
   minShotTime = 50;

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "PreAmmoCheck";
	stateSequence[0]	         = "draw";
	stateSound[0]			 = sfRevolverDrawSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
   stateTransitionOnNoAmmo[1] = "AmmoCheck";
	stateAllowImageChange[1]         = true;

	stateName[2]                     = "Fire";
	stateTransitionOnTimeout[2]      = "Smoke";
   stateSequence[2]                 = "spin";
	stateTimeoutValue[2]             = 0.14;
	stateFire[2]                     = true;
	stateAllowImageChange[2]         = false;
	stateScript[2]                   = "onFire";
	stateWaitForTimeout[2]		 = true;
	stateEmitter[2]			 = sfRevolverFlashEmitter;
	stateEmitterTime[2]		 = 0.06;
	stateEmitterNode[2]		 = "muzzleNode";
	stateSound[2]			 = sfRevolverShotSound;
   
   stateName[3]                     = "Smoke";
	stateSequence[3]                 = "spin";
	stateEmitter[3]			 = sfRevolverSmokeEmitter;
	stateEmitterTime[3]		 = 0.05;
	stateEmitterNode[3]		 = "muzzleNode";
	stateTimeoutValue[3]             = 0.5;
	stateTransitionOnTimeout[3]      = "AmmoCheck";
   
   stateName[4]			 = "PreReload";
   stateWaitForTimeout[4]		 = true;
	stateTransitionOnTimeout[4]      = "Reload";
	stateTimeoutValue[4]             = 0.2;

	stateName[5]			 = "Reload";
	stateSequence[5]                 = "open";
   stateWaitForTimeout[5]		 = true;
	stateTransitionOnTimeout[5]      = "Reload_2";
	stateTimeoutValue[5]             = 1.25;
   stateSound[5]			 = sfRevolverReloadSound;
   
   stateName[6]			 = "Reload_2";
   stateWaitForTimeout[6]		 = true;
	stateTransitionOnTimeout[6]      = "Reload_3";
	stateTimeoutValue[6]             = 0.4;
   
   stateName[7]			 = "Reload_3";
	stateSequence[7]                 = "spin";
   stateWaitForTimeout[7]		 = true;
	stateTransitionOnTimeout[7]      = "Ready";
	stateTimeoutValue[7]             = 0.4;
   stateSound[7]			 = sfRevolverSpinSound;
   stateScript[7]			 = "onReload";
   
   stateName[8]                     = "PreAmmoCheck";
	stateTransitionOnTimeout[8]      = "AmmoCheck";
	stateTimeoutValue[8]             = 0;
	stateAllowImageChange[8]         = true;
   stateScript[8]         = "onAmmoCheck";
   
   stateName[9]                     = "AmmoCheck";
   stateTransitionOnAmmo[9] = "Ready";
   stateTransitionOnNoAmmo[9] = "PreReload";
	stateAllowImageChange[9]         = true;
};

//-----------------------------------------------------------------------------
// Script

function velocityIsMoving(%obj)
{
   %plVel = %obj.getVelocity();
   %mx = getWord(%plVel, 0);
   %my = getWord(%plVel, 1);
   %mz = getWord(%plVel, 2);
   
   if(%mx > 1 || %mx < -1 || %my > 1 || %my < -1 || %mz > 1 || %mz < -1)
      return true;
   else
      return false;
}

function SFRevolverImage::onFire(%this, %obj, %slot)
{
   sfRevolverZombiesAmmo(%this, %obj, %slot);
   
   %obj.revolverAmmo -= 1;
   if(%obj.revolverAmmo < 1)
      %obj.setImageAmmo(%slot, 0);
   
   if((%obj.lastFireTime + %this.minShotTime) > getSimTime())
		return;
	%obj.lastFireTime = getSimTime();
   
   // Accuracy and damage is decreased while moving
   if(velocityIsMoving(%obj))
   {
      %spread = 0.0008;
      %projectile = SFRevolverWeakProjectile;
   }
   else
   {
      %spread = 0;
      %projectile = SFRevolverProjectile;
   }
   
   %obj.playThread(2, shiftAway);

   %vector = %obj.getMuzzleVector(%slot);
   %objectVelocity = %obj.getVelocity();
   %vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
   %vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
   %velocity = VectorAdd(%vector1,%vector2);
   %x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
   %y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
   %z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
   %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
   %velocity = MatrixMulVector(%mat, %velocity);

   %p = new (%this.projectileType)()
   {
      dataBlock = %projectile;
      initialVelocity = %velocity;
      initialPosition = %obj.getMuzzlePoint(%slot);
      sourceObject = %obj;
      sourceSlot = %slot;
      client = %obj.client;
   };
   MissionCleanup.add(%p);
	return %p;
}

function SFRevolverImage::onReload(%this, %obj, %slot)
{
   %obj.setImageAmmo(%slot, 1);
   %obj.revolverAmmo = 6;
}

function SFRevolverImage::onAmmoCheck(%this, %obj, %slot)
{
   if(%obj.revolverAmmo < 1)
      %obj.setImageAmmo(%slot, 0);
}

//-----------------------------------------------------------------------------
// Alternate Fire Reload

package revolverAlt
{
   function armor::onTrigger(%this, %player, %slot, %val)
   {
      if(%player.getMountedImage(0) $= SFRevolverImage.getID() && %slot $= 4 && %val && %player.revolverAmmo < 6)
      {
         %player.revolverAmmo = 6;
         %player.setImageAmmo(0, 0);
      }
      parent::onTrigger(%this, %player, %slot, %val);
   }
};   
activatePackage(revolverAlt);

//-----------------------------------------------------------------------------
// Rotondo's Zombies Compatibility

function sfRevolverZombiesAmmo(%this, %obj, %slot)
{
   if($AddOn__Gamemode_zombie < 1) // No zombie mod, don't bother
      return;
   
   if(isInMinigame(%obj) && %obj.client.minigame.enableAmmoMod == 1)
   {
      if(%this.melee == 1)
         return;
      
      if(%obj.zombieammo[%this.projectile] == -1)
      {
         %obj.client.bottomPrint("<just:center><color:FFFF00>Ammo <color:FFFFFF>: <just:left><color:FF0000> NONE", 3);
         return;
      }
      if(%obj.zombieammo[%this.projectile] >= 1)
      {
         %obj.zombieammo[%this.projectile]--;
         bottomPrintRemainingAmmo(%obj, %this);
      }
      if(%obj.zombieammo[%this.projectile] <= 0)
      {
         %obj.zombieammo[%this.projectile] = -1;
         
         if(isObject(%obj.getMountedImage(0).getName() @ "NoFire"))
            %obj.mountImage(%obj.getMountedImage(0).getName() @ "NoFire",0);
         
         %obj.client.bottomPrint("<just:center><color:FFFF00>Ammo <color:FFFFFF>: <just:left><color:FF0000> NONE", 3);
         %obj.playAudio(1, ammocratesound);
         %obj.playThread(2, activate2);
         return;
      }
   }
}

function sfRevolverZombies()
{
   if(isObject(gunImageNoFire))
   {
      datablock ShapeBaseImageData(sfRevolverImageNoFire : gunImageNoFire)
      {
         shapeFile = "./sfRevolver_3.dts";
         RWep = "sfRevolverImage";
         projectile = sfRevolverProjectile;
         doColorShift = sfRevolverItem.doColorShift;
         colorShiftColor = sfRevolverItem.colorShiftColor;
      };
   }
}
schedule(100, 0, sfRevolverZombies);
